#
#   ::::::::> awsac-autorun (08-10-13) <::::::::
#
#   by Jan-Philip Gehrcke (jgehrcke@gmail.com)
#   Universitt Wrzburg, Max-Planck-Institut fr Physik Mnchen
# 
#   Copyright (C) 2008 Jan-Philip Gehrcke
#
#   LICENSE:                      
#   This program is free software; you can redistribute it and/or modify 
#   it under the terms of the GNU General Public License as published by 
#   the Free Software Foundation; either version 3 of the License, or 
#   (at your option) any later version. This program is distributed in
#   the hope that it will be useful, but WITHOUT ANY WARRANTY; without
#   even the implied warranty of MERCHANTABILITY or FITNESS FOR A
#   PARTICULAR PURPOSE. See the GNU General Public License for more
#   details. You should have received a copy of the GNU General Public
#   License along with this program; if not, see
#   <http://www.gnu.org/licenses/>.
#
#   read the detailled documentation at http://gehrcke.de/awsac
#
########################################################################

echo -e "***********************************************************"
echo -e "  AWSACtools: autorun (Individual Instance Startup System)"
echo -e "    /root/awsac/awsac-autorun.sh invoked from rc.local"
echo -e "                  by Jan-Philip Gehrcke"
echo -e "                      v08-10-13"
echo -e "***********************************************************\n\n"

echo "# setting up environment variables..."
export ATLASDir=/mnt/atlas
echo ATLASDir: ${ATLASDir}
export ATLASworkingDir=/mnt/atlasworkarea
echo ATLASworkingDir: ${ATLASworkingDir}
export AWSACworkingDir=/mnt/awsac
echo AWSACworkingDir: ${AWSACworkingDir}
export SessionInfoDir=${AWSACworkingDir}/sessioninfo
echo SessionInfoDir: ${SessionInfoDir}
export SessionInfoFile=${SessionInfoDir}/awsac.sessinfo
echo SessionInfoFile: ${SessionInfoFile}
export SessionArchiveFile=${AWSACworkingDir}/sessionarchive.tar.bz2
echo SessionArchiveFile: ${SessionArchiveFile}
export AWSACAutostartFile=${AWSACworkingDir}/awsac_all_instances_autorun.sh
echo AWSACAutostartFile: ${AWSACAutostartFile}

echo "# creating directories for AWSAC and ATLAS-Software in /mnt..."
echo creating AWSACworkingDir
mkdir ${AWSACworkingDir}
echo creating SessionInfoDir
mkdir ${SessionInfoDir}
echo creating ATLASDir
mkdir ${ATLASDir}
echo creating ATLASworkingDir
mkdir ${ATLASworkingDir}
echo "# getting user-data (should contain the sessioninfostring)..."
wget http://169.254.169.254/latest/user-data -O ${SessionInfoFile}
if [ $? -eq 0 ]; then
    echo "# setting AWSenvironment variables..."
    source /root/AWS_SET_ENV_VARS.sh
    echo "# running getsessionarchive -i ${SessionInfoFile} -o ${SessionArchiveFile}"
    echo "# to get sessionarchive from S3 bucket..."
    /opt/bin/python /root/awsac/getsessionarchive -i ${SessionInfoFile} -o ${SessionArchiveFile}
    if [ $? -eq 0 ]; then
        echo "# untaring sessionarchive..."
        tar xjvf ${SessionArchiveFile} -C ${AWSACworkingDir}
            if [ $? -eq 0 ]; then
                echo "# trying to execute AWSAC autostart shellscript..."
                if [ -e ${AWSACAutostartFile} ]; then
                    source ${AWSACAutostartFile}
                else
                    echo ${AWSACAutostartFile} does not exist
                fi
            else
                echo error while untaring ${SessionArchiveFile}
            fi
    else
        echo "error in /opt/bin/python /root/awsac/getsessionarchive -i ${SessionInfoFile} -o ${SessionArchiveFile}"
    fi
else
    echo "error while retrieving user-data: AWSACtools: autorun end"
    if [ -e ${AWSACworkingDir} ]; then
        echo delete ${AWSACworkingDir}
        rm -rf ${AWSACworkingDir}
    fi
fi